> For the complete documentation index, see [llms.txt](https://developer.barchart.com/llms.txt). Markdown versions of documentation pages are available by appending `.md` to page URLs; this page is available as [Markdown](https://developer.barchart.com/getting-started/subscription-types/trades.md).

# Trades

Subscribe to `TRADES` to receive execution updates as they occur on an exchange. Each `marketUpdate` can include the latest session values and one or more individual trades.

Use these updates to track executed price, quantity, and trade side. The following full message shows trade data for December Corn.

### Trade message example

```protobuf
marketUpdate {
  marketId: 1596974561793814014
  transactionTime: 1634221354250424073
  marketSequence: 3694539
  session {
    last {
      transactionTime: 1634221354250424073
      price: 516750000000
      quantity: 2
    }
    numberOfTrades {
      numberTrades: 24286
    }
    monetaryValue {
      value: 2347631125
    }
  }
  trades {
    trades {
      trade {
        price: 516750000000
        quantity: 2
        side: OFFER
      }
    }
    trades {
      trade {
        price: 516750000000
        quantity: 1
        side: OFFER
      }
    }
    trades {
      trade {
        price: 516750000000
        quantity: 1
        side: OFFER
      }
    }
    trades {
      trade {
        price: 516750000000
        quantity: 3
        side: OFFER
      }
    }
    trades {
      trade {
        price: 516750000000
        quantity: 2
        side: OFFER
      }
    }
    trades {
      trade {
        price: 516750000000
        quantity: 1
        side: OFFER
      }
    }
    trades {
      trade {
        price: 516750000000
        quantity: 1
        side: OFFER
      }
    }
    trades {
      trade {
        price: 516750000000
        quantity: 1
        side: OFFER
      }
    }
    trades {
      trade {
        price: 516750000000
        quantity: 1
        side: OFFER
      }
    }
    trades {
      trade {
        price: 516750000000
        quantity: 1
        side: OFFER
      }
    }
    trades {
      trade {
        price: 516750000000
        quantity: 3
        side: OFFER
      }
    }
    trades {
      trade {
        price: 516750000000
        quantity: 1
        side: OFFER
      }
    }
    trades {
      trade {
        price: 516750000000
        quantity: 3
        side: OFFER
      }
    }
    trades {
      trade {
        price: 516750000000
        quantity: 1
        side: OFFER
      }
    }
    trades {
      trade {
        price: 516750000000
        quantity: 2
        side: OFFER
      }
    }
    trades {
      trade {
        price: 516750000000
        quantity: 1
        side: OFFER
      }
    }
    trades {
      trade {
        price: 516750000000
        quantity: 2
        side: OFFER
      }
    }
  }
}
```


---

# Agent Instructions
This documentation is published with GitBook. GitBook is the documentation platform designed so that both humans and AI agents can read, navigate, and reason over technical content effectively. Learn more at gitbook.com.

## Querying This Documentation
If you need additional information that is not directly available in this page, you can query the documentation dynamically by asking a question.

Perform an HTTP GET request on the current page URL with the `ask` query parameter, and the optional `goal` query parameter:

```
GET https://developer.barchart.com/getting-started/subscription-types/trades.md?ask=<question>&goal=<endgoal>
```

`ask` is the immediate question: it should be specific, self-contained, and written in natural language.
`goal` is optional and describes the broader end goal you are ultimately trying to accomplish on behalf of the user. GitBook uses it to tailor the answer towards what is most useful for that goal.

The response will contain a direct answer to the question and relevant excerpts and sources from the documentation.

Use this mechanism when the answer is not explicitly present in the current page, you need clarification or additional context, or you want to retrieve related documentation sections.
